
/* global $ */
/* @depend TablesorterController.js */

Function.prototype.bind = Function.prototype.bind || function (thisp) {
    var fn = this;

    return function () {
        return fn.apply(thisp, arguments);
    };
};

var QfqNS = QfqNS || {};

$(document).ready( function () {
    (function (n) {

        try {
            var tablesorterController = new n.TablesorterController();
            $('.tablesorter').each(function (i) {
                tablesorterController.setup($(this), i);
            }); // end .each()

        $('.tablesorter-filter').addClass('qfq-skip-dirty');
        $('select.qfq-tablesorter-menu-item').addClass('qfq-skip-dirty');
        $('.tablesorter-column-selector>label>input').addClass('qfq-skip-dirty');
        // This is needed because after changing table-view, class of input field is empty again
        $('button.qfq-column-selector').click(function () {
            $('.tablesorter-column-selector>label>input').addClass('qfq-skip-dirty');
        });
    } catch (e) {
        console.log(e);
    }

        $('.qfq-auto-grow').each(function() {
            var minHeight = $(this).attr("rows") * 14 + 18;
            var newHeight = $(this).prop('scrollHeight');
            var maxHeight = $(this).data('max-height') || 0;

            if ($(this).val === '' || newHeight < minHeight) {
                return;
            }

            if (newHeight < maxHeight || maxHeight === 0) {
                $(this).height(newHeight);
            } else {
                $(this).height(maxHeight);
            }
        });

        $('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
            $('.qfq-auto-grow').each(function () {
                var minHeight = $(this).attr("rows") * 14 + 18;
                var newHeight = $(this).prop('scrollHeight');
                var maxHeight = $(this).data('max-height') || 0;

                if ($(this).val === '' || newHeight < minHeight) {
                    return;
                }

                if (newHeight < maxHeight || maxHeight === 0) {
                    $(this).height(newHeight);
                } else {
                    $(this).height(maxHeight);
                }
            });
        });

        $('.qfq-auto-grow').on('input paste', function() {
            var newHeight = $(this).prop('scrollHeight');
            var maxHeight = $(this).data('max-height') || 0;
            if ($(this).outerHeight() < newHeight) {
                if(newHeight < maxHeight || maxHeight === 0) {
                    $(this).height(newHeight);
                }
            }
        });

        $('.qfq-clear-me').each(function() {
            var myInput = $(this);
            if(!myInput.is("input,textarea")) {
                return;
            }
            var closeButton = $("<span>", {
                class: "qfq-clear-me-button",
                html: "&times;"
            });
            if (myInput.val() == '' || myInput.is('[disabled=disabled]')) {
                closeButton.addClass("hidden");
            }
            closeButton.on("click", function(e) {
                myInput.val('');
                closeButton.addClass("hidden");
            });
            $(this).after(closeButton);
            $(this).on("input", function() {
                if(myInput.val() != '' && !myInput.is('[disabled=disabled]')) {
                    closeButton.removeClass("hidden");
                } else {
                    closeButton.addClass("hidden");
                }
            });

        });


        $('.qfq-clear-me-multiform').each(function() {
            var myInput = $(this);
            if(!myInput.is("input,textarea")) {
                return;
            }
            var closeButton = $("<span>", {
                class: "qfq-clear-me-multiform-button",
                html: "&times;"
            });
            if (myInput.val() == '' || myInput.is('[disabled=disabled]')) {
                closeButton.addClass("hidden");
            }
            closeButton.on("click", function(e) {
                myInput.val('');
                closeButton.addClass("hidden");
            });
            $(this).after(closeButton);
            $(this).on("input", function() {
                if(myInput.val() != '' && !myInput.is('[disabled=disabled]')) {
                    closeButton.removeClass("hidden");
                } else {
                    closeButton.addClass("hidden");
                }
            });

        });

        $('.qfq-datepicker').each(function() {
            var dates = {};
            var dateArray = {};
            var datesToFormat = ["minDate", "maxDate"];
            var correctAttributeNames = ["mindate", "maxdate"];
            var onlyTime = false;
            for(var i = 0; i < datesToFormat.length; i++) {
                var date = false;
                if($(this).data(correctAttributeNames[i])) {
                    var cleanDate = $(this).data(correctAttributeNames[i]).split(" ")[0];
                    var cleanTime = $(this).data(correctAttributeNames[i]).split(" ")[1];
                    if(cleanDate.includes('.')) {
                        dateArray = cleanDate.split(".");
                        date = dateArray[1] + "/" + dateArray[0] + "/" + dateArray[2];
                    } else if(cleanDate.includes('-')){
                        dateArray = cleanDate.split("-");
                        date = dateArray[1] + "/" + dateArray[2] + "/" + dateArray[0];
                    } else {
                        var today = new Date();
                        var dd = String(today.getDate()).padStart(2, '0');
                        var mm = String(today.getMonth() + 1).padStart(2, '0'); //January is 0!
                        var yyyy = today.getFullYear();
                        date = mm + "/" + dd + "/" + yyyy + " " + cleanDate;
                        onlyTime = true;
                    }
                    if(cleanTime !== '' && cleanTime !== undefined) {
                        date = date + " " + cleanTime;
                    } else if(correctAttributeNames[i] === "maxdate" && !onlyTime) {
                        date = date + " 23:59:59";
                    }
                }
                dates[datesToFormat[i]] = date;
            }

            var options = {
                locale: $(this).data("locale") || "en",
                daysOfWeekDisabled: $(this).data("days-of-week-disabled") || [],
                minDate: dates.minDate,
                maxDate: dates.maxDate,
                format: $(this).data("format") || "DD.MM.YYYY HH:mm",
                viewMode: $(this).data("view-mode-default") || "days",
                showClear: ($(this).data("show-clear-button") !== undefined) ? $(this).data("show-clear-button") : true,
                calendarWeeks: ($(this).data("show-calendar-weeks") !== undefined) ? $(this).data("show-calendar-weeks") : false,
                useCurrent: ($(this).data("use-current-datetime") !== undefined) ? $(this).data("use-current-datetime") : false,
                sideBySide: ($(this).data("datetime-side-by-side") !== undefined) ? $(this).data("datetime-side-by-side") : true,
            };

            var currentDatePicker = $(this).datetimepicker(options);


        });





        n.Helper.calendar();

    })(QfqNS);
});


